/*
** baseinc.h
**
** Standard necessary includes & definitions
*/



#if !defined(BASEINC_H)

#define BASEINC_H

#include <stdlib.h> /*Necessary for NULL and malloc*/


/*Type declarations*/
typedef unsigned char byte;      /*8  bit unsigned*/
typedef signed char sbyte;       /*8  bit signed*/
typedef unsigned short int word; /*16 bit unsigned*/
typedef signed short int sword;  /*16 bit signed*/
typedef unsigned int dword;      /*32 bit unsigned*/
typedef signed int sdword;       /*32 bit signed*/
typedef unsigned int adint;      /*Architecture - dependent integers (size>=32bit)*/
typedef signed int sadint;



/*A binary tweak where no initial value is necessary, but the variale is static*/
#define INT_RUCH ('R'+('u'<<8)+('C'<<16)+('h'<<24))



/*This type is used for storing 32bit / 8bit uncompressed images
**and for the screen itself*/

typedef struct{ /*An image's descriptor*/
 adint x;   /*X / Y sizes*/
 adint y;
 adint p;   /*Pitch: Absolute X size - might be larger than x.*/
 dword *i;  /*32 bit (ARGB) image data or palette*/
            /*ARGB layout:
            **(A<<24)+(B<<16)+(G<<8)+R*/
 byte  *c;  /*Indicates format too: if null, then 32bit image,
            **else this holds 8bit image data and *i is for the
            **palette.*/
}tImage;

#endif
