/*
** blit32.h
**
** Simple blitter to update a destination image part with a source
*/


#if !defined(BLIT32_H)
#define BLIT32_H

#include "baseinc.h"


/*Blit32
**Blits from source to destination, respects source's alpha,
**dest's transparency is zeroed if any
**Note: does not check anything
*/
void Blit32(tImage* src, tImage* dst, adint xs, adint ys, adint xd, adint yd, adint w, adint h);

/*Mix32
**Mixes src on dst: both may be images with transparency data: the result then
**will also have appropriate transparency data. The two image's x,y,and pitch
**has to be identical (Does not check!). m is for how much from src should be
**taken: 0: nothing, 256: all*/
void Mix32(tImage* src, tImage* dst, dword m);

/*Clears a region to the given color*/
void Clear32(adint x, adint y, adint w, adint h, dword col, tImage* dest);


#endif
