/*
** cvstr.c
**
** Converts numeric input to string representation
*/



#include "baseinc.h"
#include "cvstr.h"



/*int CvStr(unsigned int in, int of, char* op)
**
** Converts input to string, placed at op, using format specified
** in of. Format:
**  With 0-11 the maximal length of the output can be given
**  CVSTR_FIXED can be used for fixed output size (pad with zeros)
**  CVSTR_SIGNED is to treat input as signed
**  CVSTR_POSITIVE turns on CVSTR_SIGNED and displays the '+' sign
**  CVSTR_HEX creates hexadecimal output
**  CVSTR_LCASE causes hex output to be lower case
** op has to be capable to hold the output.
** Returns the number of characters written (needed when the output
** size is not fixed
*/
adint CvStr(adint in, adint of, byte* op)
{
 adint div, divs, divc;
 adint digit,i,oc=0;
 
 if ((of & 0xFF)==0) return 0;
 /*Sign of the number*/
 if (of & CVSTR_SIGNED)
  if ((of & CVSTR_POSITIVE) || (((signed int)in)<0)){
   if ((of & 0xFF)==1) return 0;
   of=(of & 0xFFFFFF00)+((of & 0xFF)-1);
   if (((signed int)in)<0){
    *op='-';
    in=(-((signed int)in));
   }else *op='+';
   op++;
   oc++;
  }

 /*Setting up divisor for hex / decimal output*/
 if (of & CVSTR_HEX){
  div=0x10000000;
  divs=0x10;
  divc=8;
 }else{
  div=1000000000;
  divs=10;
  divc=10;
 }
 
 for(i=divc;i>0;i--){
  /*One digit...*/
  if (i<divc){
   digit=in%div;
   div/=divs;
  }else digit=in;
  digit/=div;
  /* > output size?*/
  if ((i>(of & 0xFF)) && digit){
   if (of & CVSTR_HEX) in=0xFFFFFFFF;
   else in=999999999;
  }
  /*Output digit when necessary*/
  if (i<=(of & 0xFF)){
   if (digit || (of & CVSTR_FIXED)){
    of|=CVSTR_FIXED; /*From now output all*/
    if (digit<10) *op=digit+'0';
    else if (of & CVSTR_LCASE) *op=digit-10+'a';
    else *op=digit-10+'A';
    op++;
    oc++;
   }
  }
 }
 
 return oc;
}
