/*
** gamemain.c
**
** The game loop: realizes the actual game
*/



#if !defined(GAMEMAIN_H)
#define GAMEMAIN_H

#include "baseinc.h"


#define GAME_HALT 0x80
#define GAME_EXIT 0x81
#define GAME_DIED 0x01
#define GAME_DIAM 0x00
#define GAME_NEXT 0x10
#define GAME_PREV 0x11

#define GAME_NOUPD 0x10000


/*Game_SetLang
**Sets language - specific texts
**Gets a pointer to six pointers which point to these texts in order
**(Restart, Next lv, Prev lv, Skip mv, Exit, the scrolltext)
**NULL does not change*/
void Game_SetLang(byte** lang);
/*Game_SetCol
**Gets three colors: background, mouse, and text color*/
void Game_SetCol(dword bg, dword m, dword t);

/*After setting up a map this will run the game.*/
/*-1 tells if some critical fault happened,
**positive values (and zero) are for normal termination
** GAME_HALT: Exit from the whole program requested
** GAME_EXIT: Exit from the game requested (ESC)
** GAME_DIED: Kye died, take care of substracting from lives ect. (ENTER)
** GAME_DIAM: All diamonds were collected
** GAME_NEXT: Request for next level (PgUp)
** GAME_PREV: Request for prev level (PgDn)
**Keys:
** Arrows; numpad: move
** Numpad 5: Skip a move (in turn - based mode)
**levtxt is an array of 10 pointers: level name, level hint, and 8 help block
**texts. NULL can be given to leave empty an area
**in flags the number of lives can be passed (to output it on screen), and
**the GAME_NOUPD flag to ask to not redraw the decorating borders
*/
sadint Game_Main(byte** levtxt,adint flags);


#endif
