/*
** geffects.h
**
** Graphic effects: various graphic stuff, mostly graphic effects
*/


#if !defined(GEFFECTS_H)
#define GEFFECTS_H


#include "baseinc.h"


/*Prepares a tImage structure to be a "window" in an another one
**returns true if window could be made among filling dest, otherwise
**zero and NULL in dest->i*/
adint MakeWindow(tImage* src, sadint x, sadint y, sadint w, sadint h, tImage* dest);

/*Pixelizes an area
**fade also darkens it: 256: normal intensity; 0: black
**pix is the size of pixels<<8. Fractional sizes are handled this way
**appropriately.
**Note: much faster when using larger pixels!
*/
void Effect_Pixelize(adint x, adint y, adint w, adint h,
                     adint fade, adint pix, tImage *dest);
/*RandomMap
**Generates a random style 'map', may be used for background
**randomness also depends on what was on - screen before, so it may be better
**to use on filled screen
**xs and ys are for x and y maximal allowed color change <<8 (256 means it is
**possible that a col1 folows a col2 pixel)*/
void Effect_RandomMap(dword col1, dword col2, sadint xs, sadint ys, tImage* dest);

/*Create a three - dimensional looking border by appliing colul on the upper -
**left corner, colbr on the bottom right. (Use transparent black & white for
**the traditional effect) Note that the given coordinates have to be on -
**dest: it does not handle partial off - dest stuff*/
void Effect_3DBorder(dword colul, dword colbr, sadint x, sadint y, adint w, adint h, tImage* dest);
/*Like the above, but may be also used for thicker borders*/
void Effect_3DBorderT(dword colul, dword colbr, adint s, sadint x, sadint y, adint w, adint h, tImage* dest);


#endif
