/*
** iconvppc.c
**
** Displays PPC images from the format generated by ppciconv, currently
** for only up to 64 colors (256 byte palette... The Cheetah ASCII - art
** could be included here!)
*/

#include "baseinc.h"
#include "ppcdec.h"
#include "iconvppc.h"


byte iconvppc_pal[64*sizeof(dword)]={
 0x0D,0x0A,0x0D,0x0A,  /*4*/
 ' ', ' ', ' ', ' ', ' ', '<', '\\','-', ',', 0x0D,0x0A,   /*11*/
 ' ', ' ', ' ', '.', '/', ' ', '\\','_', '_', '>', ' ', ' ', 'R', 'u', 'C', 'h', 0x0D,0x0A,  /*18*/
 ' ', ' ', '/', '\'',' ', ' ', '<', 0x0D,0x0A,   /*9*/
 ' ', '|', ' ', ',', ',', ' ', ' ', '\\',' ', 'r', 'u', 'c', 'h', '.', 'c', 'o', '.', 'n', 'r', 0x0D,0x0A,  /*21*/
 ' ', '|', '/', '\'','`', '\\',' ', '>', '|', 0x0D,0x0A,  /*11*/
 ' ', '|', '|', '\\','/', '|', '|', ' ', '`', '\\',' ', ' ', '<', '~', '\\',' ', ' ', 'F', 0x0D,0x0A,  /*20*/
 ' ', '|', '|', '`', '\\','|', '|', ' ', ' ', '`', '\\',',', ' ', '~', '\\','|', ' ', 'r', 0x0D,0x0A,  /*20*/
 ' ', '|', '|', ' ', '`', '|', '|', '\\','_', '(', ' ', ' ', '\\',' ', '/', '|', ' ', 'e', 0x0D,0x0A,  /*20*/
 ' ', '|', '|', ' ', ' ', '|', '|', '_', '\\',' ', '\\',' ', '|', '~', '/', '\'',' ', 'e', 0x0D,0x0A,  /*20*/
 '(', 'W', ')', ' ', '(', 'W', ')', '_', '(', 'W', '_', '_', '|', '~', 0x0D,0x0A,  /*16*/
 /*170*/
 0x0D,0x0A,  /*2*/
 'Y','o','u',' ','a','r','e',' ','n','o','t',' ','a','n',' ',  /*15*/
 'A','S','M',' ','g','u','r','u',',',' ','o','k','?','?','!',  /*15*/
 0x0D,0x0A,  /*2*/
 'S','t','o','p',' ','m','e','s','s','i','n','g',' ','w','i','t','h',' ','t','h','i','s','!',  /*23*/
 ' ',':','3',  /*3*/
 /*60 + 170 = 230*/
 0x0D,0x0A,0x0D,0x0A,  /*4*/
 'P','r','o','u','d',' ','t','o',' ','b','e',' ','F','u','r','r','y','!', /*18*/
 0x0D,0x0A,0x0D,0x0A};
/*
**      <\-,
**    ./ \__>  RuCh
**   /'  <
**  | ,,  \ ruch.co.nr
**  |/'`\ >|
**  ||\/|| `\  <~\  F
**  ||`\||  `\, ~\| r
**  || `||\_(  \ /| e
**  ||  ||_\ \ |~/' e
** (W) (W)_(W__|~
** You are not an ASM guru, ok??!
** Stop messing with this! :3
** 
** Proud to be Furry!
*/



/*Displays a PPCIConv image
**x and y are on dest location (The image must fit on!)
**fade (256 for original) is to fade it out if needed
**transp: transparent color index (A color should be substitued by
**transparent. Usually the PPCIConv images have transparency since
**that way they can be smaller, so this may be necessary. Give a big
**number to ignore)*/
void PPC_Iconv_Disp(byte* ppc, sadint x, sadint y, adint fade, adint transp, tImage *dest)
{
 adint i, sy, ncl=((adint)(*ppc))+1;
 
 ppc++;
 if (ncl>64) return;

 /*Process palette data*/
 for(i=0;i<ncl;i++){
  ((dword*)iconvppc_pal)[i]=(( (((dword)  *ppc)*fade)>>8 )<<16)
                           +(( (((dword)ppc[1])*fade)>>8 )<<8)
	                   + ( (((dword)ppc[2])*fade)>>8 );
  ppc+=3;
 }
 if (transp<64) ((dword*)iconvppc_pal)[transp]=0xFF000000; /*Transparent*/
 sy=(((adint)(*ppc))<<8)+((adint)ppc[1]);
 ppc+=2;

 /*Display*/
 PPC_Disp(ppc,sy,(dword*)iconvppc_pal,x,y,dest);
}
