/*
** intens.h
**
** intensity map handling on 32bit ARGB surfaces
*/


#if !defined(INTENS_H)
#define INTENS_H


#include "rot.h"
#include "baseinc.h"


#define INTENS_T  0x100




/*Indexes an intensity map data
**This speeds up displaying
**imap is the traditional format intensity map, idx is the place to write
**the indexes to*/
void Intens_Index(byte* imap, adint* idx);

/*Outputs one from the intensity maps
**imap is the intensity map,
**ino is the image number to copy
**idx points to the index for the intensity map. Can be NULL (slower)
**color is the color to use when displaying (repeatedely using the same is faster!)
**flags:
** Rotation flags, and
** INTENS_T to preserve original's transparency (transparent put)
**x,y: destination upper - left corner
**dest: destination surface
**Note that partial intensity maps will NOT be drawn!
**Returns a width & height combination: height<<8 + width*/
adint Intens_Out(byte* imap, adint ino, adint* idx,
                 dword color, adint flags,
 	 	 sadint x, sadint y, tImage* dest);

#endif
