/*
** kyeinter.h
**
** Kye interactions
** Note that Kye has to be the first member (0) of the object chain
** since it can do such special interactions which need it to be the
** first.
*/


#if !defined(KYEINTER_H)
#define KYEINTER_H

#include "baseinc.h"



/*Calculates interactions in a frame for every object. The frame is
**static: Kye moves one unit in 8 frames, sliders, rockies do so as
**well, movers move in 16 etc.
**Gets: Kye's movement request:
** bit 0-3: Moves Up / Left / Down / Right
**Returns: A flag set:
** bits:
** 0: Set in each 8th frame (when Kye is on a block)
** 1: When message is available (later - help boxes)
** 2: When message is cancelled (later)
** 3: Kye died
** 4: Set if a diamond was collected
**    This case bit 8-11 will get the frame (object variant)
*/
adint Kye_Interact(adint move);

/*Returns 1 if interaction frame comes*/
adint Kye_InteractFrame();

/*Resets interaction*/
void Kye_Interact_Reset();

#endif
