/*
** kyeintms.c
**
** Kye interactions
** Some misc. functions used by both special and base object interactions
*/



#if !defined (KYEINTMS_H)
#define KYEINTMS_H

#include "baseinc.h"


/*Returns 1 if a block is filled with anything
**msig is the movement signature how the requesting object wishes to
**enter the checked block. If given, and only one bit, it will also check
**if doors are allowing pass or a slow moving object is exitting
**bit 7 of msig specifies if the object is Kye*/
adint Kye_I_Filled(sadint x, sadint y, adint msig);

/*Gets allocation signature around object. Bits are ordered this
**way:
**0 1 2
**3   4
**5 6 7
from msig only bit 7 is used: Kye*/
adint Kye_I_Alloc(sadint x, sadint y, adint msig);

/*Kye_I_Hit
**Returns object ID which the object would hit when moving with the given
**movement signature (-1 if no object)*/
sadint Kye_I_Hit(sadint x, sadint y, adint msig);

/*Gets an x and y location and a movement signature & round flag,
**then returns a new movement signature how the object may move.
**(movr 0-3: movement sig., movr 4: round flag)
**movf is the movement the object already have: it is fixed, can not
**be altered
**In the return value bit 4 is set if the native velocity should be
**halved for a frame*/
adint Kye_I_Move(sadint x, sadint y, adint movr, adint movf, sadint id);

/*Setting an object*/
void Kye_I_SetObject(sadint id, tKyeObject* o);

#endif
