/*
** kyeispec.c
**
** Kye interactions - object - specific specials
*/



#if !defined (KYEISPEC_H)
#define KYEISPEC_H

#include "baseinc.h"



/*Routines:
**Kye_IS_Meet(id,id)
**Returns 1 if, and only if it has sense to push two objects on each other
**as the said two objects have some interaction
**Kye_IS_MeetAct(id,*obj)
**From the object's propeties (movement) determines if some sort of running
**on each other happens, then sets up the receiver to act, and returns 1
**(also locks the movement of the one given)
**Kye_IS_IFrameNV(id,*obj,nv)
**If some pre - work has to be done on native velocity (like magnets)
**Kye_IS_IFrame(id,*obj,nv)
**Special object effects should be carried out in every interation
**(usually 8th) frame. nv is the currently calculated native velocity
**signature. Returns some propeties:
** 1: When message is available (later - help boxes)
** 2: When message is cancelled (later)
** 3: Kye died
** 4: Set if a diamond was collected
**    This case bit 8-11 will get the frame (object variant)
**(Others: 0)
**Kye_IS_Frame(id,*obj)
**Special effects should be carried out in every frame
*/

adint Kye_IS_Meet(sadint id1, sadint id2);
adint Kye_IS_MeetAct(sadint id, tKyeObject* obj);
adint Kye_IS_IFrameNV(sadint id, tKyeObject* obj, adint nv);
adint Kye_IS_IFrame(sadint id, tKyeObject* obj, adint nv);
void  Kye_IS_Frame(sadint id,tKyeObject *obj);

#endif
