/*
** kyemapmn.c
**
** Frontend for the parts kyemap, kyemapup, and kyeolist
*/


#include "baseinc.h"
#include "kyemap.h"
#include "kyemapup.h"
#include "kyeolist.h"
#include "kyemapmn.h"
#include "kyeobjs.h"





/*Kye_MapClose
**Frees resources asllocated*/
void (**kye_mapmnobjlist) (sadint,sadint,sadint,sadint,tImage*)=NULL;
void Kye_MapClose()
{
 free(kye_mapmnobjlist);
 Kye_OB_Free();
 Kye_MapFree();
}


/*Kye_MapSetup
**Fires up the map updater & map related routines
**x and y are the locations where the map sits on the screen.
**Note: bgimage still has to be passed!
**Returns 1 on failure (If the map allocation failed)*/
adint Kye_MapSetup(adint x, adint y)
{
 adint i;
 Kye_ScrPos(x,y);
 if ((kye_mapmnobjlist=malloc(sizeof(void(**)(sadint,sadint,sadint,sadint,tImage*))*256))==NULL) return 1;
 for (i=0;i<KYE_OBJLISTN;i++) kye_mapmnobjlist[i]=kye_objlist[i];
 while (i<256){ kye_mapmnobjlist[i]=NULL; i++; }
 Kye_ObjFuncList(kye_mapmnobjlist);
 Kye_MapFuncList(kye_maplist);
 i=Kye_OB_Alloc() || Kye_MapAlloc();
 if (i) Kye_MapClose();
 return i;
}


/*Kye_NewObject
**Creates a new object, returns -1 on failure, otherwise object ID
**rot is from 0 to 3: the initial direction of the object (if it can have
**direction), bits above will be set in the low 4 bits of frame (variant
**selector). attr are for other attributes, if any (rare). Or-ing
**KYE_NEW_TROT to the attributes may be used to transfer the higher 8 bits
**of it to the rotation (If precise rotation is needed)*/
sadint Kye_NewObject(sadint x, sadint y, adint type, adint rot, adint attr)
{
 adint id;
 tKyeObject o;
 if (type>=KYE_OBJLISTN) return -1;
 if ((id=Kye_GetFreeObj())==-1) return -1;
 o.x=x<<8;
 o.y=y<<8;
 o.t=type;
 if (attr & KYE_NEW_TROT) o.r=(attr>>8) & 0xFF;
 else o.r=(rot & 0x3)<<6;
 o.m=0;
 o.s=kye_objlistp[type] & 0xFF;
 o.p=kye_objlistp[type]>>8;
 o.a=attr & 0xFF;
 o.k=0;
 o.f=(rot & 0x3C)>>2;
 Kye_ObjSet(id,&o);
 return id;
}
