/*
** kyemapmn.h
**
** Frontend for the parts kyemap, kyemapup, and kyeolist
*/


#if !defined(KYEMAPMN_H)
#define KYEMAPMN_H


#include "baseinc.h"
#include "kyemap.h"
#include "kyemapup.h"


/*Note: "Produced" objects have to follow their "producer": a simplification
**in the engine (Sliders, rockyes). See kyeolist.h*/

#define KYE_O_KYE        0
#define KYE_O_BLOCK      1
#define KYE_O_RBLOCK     2
#define KYE_O_CLOCKER    3
#define KYE_O_ASLIDER    4
#define KYE_O_SLIDER     5
#define KYE_O_AROCKY     6
#define KYE_O_ROCKY      7
#define KYE_O_MOVER      8
#define KYE_O_DIAMOND    9
#define KYE_O_EBLOCK    10
#define KYE_O_ERBLOCK   11
#define KYE_O_TBLOCK    12
#define KYE_O_MAGNET    13
#define KYE_O_BLACK     14
#define KYE_O_VIRUS     15


#define KYE_NEW_TROT    0x10000
/*For Kye_NewObject: transfer the higher 8 bits of attr in rotation to give
**precise rotation where necessary*/


/*Kye_MapSetup
**Fires up the map updater & map related routines
**x and y are the locations where the map sits on the screen.
**Note: bgimage still has to be passed!
**Returns 1 on failure (If the map allocation failed)*/
adint Kye_MapSetup(adint x, adint y);
/*Kye_MapClose
**Frees resources asllocated*/
void Kye_MapClose();

/*Kye_NewObject
**Creates a new object, returns -1 on failure, otherwise object ID
**rot is from 0 to 3: the initial direction of the object (if it can have
**direction), bits above will be set in the low 4 bits of frame (variant
**selector). attr are for other attributes, if any (rare)*/
sadint Kye_NewObject(sadint x, sadint y, adint type, adint rot, adint attr);


#endif
