/*
** kyemapup.h
**
** Map updater. Using the dirty flags of the map it updates the
** necessary screen areas
*/


#if !defined(KYEMAPUP_H)
#define KYEMAPUP_H

#include "baseinc.h"



/*Kye_ScrPos
**This sets where is the upper - left corner of the map on the screen*/
void Kye_ScrPos(adint x, adint y);
/*Kye_SetBGImage
**sets background image to use. Must be called at least once before drawing
**maps!*/
void Kye_SetBGImage(tImage* bg);
/*Kye_ObjFuncList
**Kye_MapFuncList
**Passes a pointer list to the functions need to be called to draw each
**object type. It has to have 128 elements, optionally with NULLs where
**necessary
**MapFuncList is the same for map blocks; there 8 functions are needed*/
void Kye_ObjFuncList(void (**funclist) (sadint,sadint,sadint,sadint,tImage*));
void Kye_MapFuncList(void (**funclist) (sadint,sadint,sadint,sadint,tImage*));

/*Kye_Update
**Updates everything appropriately on the map, and displays them*/
void Kye_Update();

#endif
