/*
** kyeobase.c
**
** Functions & data only used by kyeobjs.c
*/


#include "baseinc.h"
#include "kyeoint.h"
#include "intens.h"
#include "blit32.h"




dword kye_colors[15]={
 0x555555,
 0x44EE22,
 0xEEDD11,
 0xEE5522,
 0x2222EE,
 0x888888,
 0x111111,
 0xEE11DD,
 0x779977,
 0x334455EE,
 0x339999EE,
 0x000000,
 0x66EE3311,
 0x775555EE,
 0x8833EE33
};
 
adint* kye_index_s=NULL,
     * kye_index_i=NULL,
     * kye_index_o=NULL,
     * kye_index_b=NULL;
     
tImage kye_mixtmp[2]={ /*Images for mixing to give better quality animations*/
 {16, 16, 16, NULL, NULL},
 {16, 16, 16, NULL, NULL}
};


/*Cleans the mix images to transparent*/
void Kye_OB_NewMix()
{
 adint i;
 for (i=0;i<512;i++) (kye_mixtmp[0].i)[i]=0xFF000000;
}


/*LinearSelect
**Downsamples a larger set of values to a smaller set among returning how two
**adjacent values should be mixed to get a better representation of the
**original (how much to take from the returned value; 256-m: how much from the
**following)*/
adint Kye_OB_LinearSelect(adint inv, adint inmax, adint omax, adint* m)
{
 adint t;
 t=inv*omax;
 *m=256-(((t%inmax)<<8)/inmax);
 return t/inmax;
}


/*Base
**Needed by various things: basement*/
void Kye_OB_Base(sadint x, sadint y, tImage* dest, adint out, dword col, dword bcol)
{
 Intens_Out(kye_out,out,kye_index_o,bcol,INTENS_T,x,y,dest);
 Intens_Out(kye_out,out,kye_index_o,bcol,INTENS_T | MIR_Y,x+8,y,dest);
 Intens_Out(kye_out,out,kye_index_o,bcol,INTENS_T | MIR_X,x,y+8,dest);
 Intens_Out(kye_out,out,kye_index_o,bcol,INTENS_T | MIR_Y | MIR_X,x+8,y+8,dest);
 Intens_Out(kye_in,out,kye_index_i,col,INTENS_T,x+2,y+2,dest);
 Intens_Out(kye_in,out,kye_index_i,col,INTENS_T | MIR_Y,x+8,y+2,dest);
 Intens_Out(kye_in,out,kye_index_i,col,INTENS_T | MIR_X,x+2,y+8,dest);
 Intens_Out(kye_in,out,kye_index_i,col,INTENS_T | MIR_Y | MIR_X,x+8,y+8,dest);
}

/*MixBase
**Like the above, but prepares in the mixer area*/
void Kye_OB_MixBase(adint out, dword col, dword bcol)
{
 adint i;
 Kye_OB_NewMix();
 Intens_Out(kye_out,out,kye_index_o,bcol,0,0,0,&kye_mixtmp[0]);
 Intens_Out(kye_out,out,kye_index_o,bcol,MIR_Y,8,0,&kye_mixtmp[0]);
 Intens_Out(kye_out,out,kye_index_o,bcol,MIR_X,0,8,&kye_mixtmp[0]);
 Intens_Out(kye_out,out,kye_index_o,bcol,MIR_Y | MIR_X,8,8,&kye_mixtmp[0]);
 Intens_Out(kye_in,out,kye_index_i,col,INTENS_T,2,2,&kye_mixtmp[0]);
 Intens_Out(kye_in,out,kye_index_i,col,INTENS_T | MIR_Y,8,2,&kye_mixtmp[0]);
 Intens_Out(kye_in,out,kye_index_i,col,INTENS_T | MIR_X,2,8,&kye_mixtmp[0]);
 Intens_Out(kye_in,out,kye_index_i,col,INTENS_T | MIR_Y | MIR_X,8,8,&kye_mixtmp[0]);
 /*Just copy it in the secondary mixer*/
 for (i=0;i<256;i++) (kye_mixtmp[1].i)[i]=(kye_mixtmp[0].i)[i];
}


/*RotSel
**Selects images & flags according to the given 0-23 rotation (INTENS_T
**will NOT be set)
**(use when a 0, a 15, a 30, and a 45 degree image is there in order)*/
adint Kye_OB_RotSel(adint *ino, adint rot)
{
 adint flags=0;
 switch (rot%6){
  case 0: *ino=0; break;
  case 1: *ino=1; break;
  case 2: *ino=2; break;
  case 3: *ino=3; break;
  case 4: *ino=2; flags|=MIR_XY45 | MIR_X | MIR_Y; break;
  default:*ino=1; flags|=MIR_XY45 | MIR_X | MIR_Y;
 }
 if (rot>=6){
  if (rot<12){
   if (flags & MIR_XY45) flags&=0xFFFFFFFF-MIR_XY45; else flags|=MIR_XY45;
   if (flags & MIR_Y) flags&=0xFFFFFFFF-MIR_Y; else flags|=MIR_Y;
  }else if (rot<18){
   if (flags & MIR_X) flags&=0xFFFFFFFF-MIR_X; else flags|=MIR_X;
   if (flags & MIR_Y) flags&=0xFFFFFFFF-MIR_Y; else flags|=MIR_Y;
  }else{
   if (flags & MIR_X) flags&=0xFFFFFFFF-MIR_X; else flags|=MIR_X;
   if (flags & MIR_XY45) flags&=0xFFFFFFFF-MIR_XY45; else flags|=MIR_XY45;
  }
 }
 return flags;
}


/*Rot (Obsolete)
**Sets up the drawing flag & img no according to the rotation
**(Use when a 0, a 15, a 30, and a 45 degree image is present in order)*/
/*MixRot
**like the above, but sets up two image numbers for mixing together and a
**mixing ratio specifiing how much has to be taken from the first*/
void Kye_OB_MixRot(adint *ino1, adint *flags1, adint *ino2, adint *flags2, adint *mix, sadint rot)
{
 adint q=Kye_OB_LinearSelect(rot,256,24,mix);
 *flags1=INTENS_T | Kye_OB_RotSel(ino1,q);
 *flags2=INTENS_T | Kye_OB_RotSel(ino2,(q+1)%24);
}


/*Kye_OB_MixAlpha
**Mixes two alpha values appropriately (0-255 each)*/
dword Kye_OB_MixAlpha(dword a1, dword a2)
{
 return 255-((255-a1)*(255-a2)/255);
}

/*Kye_OB_AddAlpha
**adds more transparency to a color, returns the new color*/
dword Kye_OB_AddAlpha(dword col, dword a)
{
 return (col & 0xFFFFFF) | (Kye_OB_MixAlpha(col>>24,a)<<24);
}

/*Kye_OB_MixCol
**Mixes two colors by taking m of the first, and 256-m of the second*/
dword Kye_OB_MixColor(dword c1, dword c2, dword m)
{
 return 
  (( ((( c1     & 0xFF00FF)*m) & 0xFF00FF00) + ((( c2     & 0xFF00FF)*(256-m)) & 0xFF00FF00) )>>8) +
     ((((c1>>8) & 0xFF00FF)*m) & 0xFF00FF00) + ((((c2>>8) & 0xFF00FF)*(256-m)) & 0xFF00FF00) ;
}


/*SR
**Internal stuff for slider or rocky (As they are drawn the same way)
**Also used for auto - slider & auto - rocky
**Automatically uses the mixer if possible*/
void Kye_OB_SR(sadint rot, sadint frame, sadint x, sadint y, tImage* dest, adint shape, adint out, dword col, dword tr)
{
 adint ino1, flags1, ino2, flags2, mix;
 dword col2=Kye_OB_AddAlpha(kye_colors[2],tr),
       col0=Kye_OB_AddAlpha(kye_colors[0],tr);
       col =Kye_OB_AddAlpha(col          ,tr);
 
 Kye_OB_MixRot(&ino1,&flags1,&ino2,&flags2,&mix,rot);
 Kye_OB_MixBase(out, col2, col0);
 Intens_Out(kye_shap,ino1+shape,kye_index_s,col,flags1,2,2,&kye_mixtmp[0]);
 Intens_Out(kye_shap,ino2+shape,kye_index_s,col,flags2,2,2,&kye_mixtmp[1]);
 Mix32(&kye_mixtmp[0],&kye_mixtmp[1],mix);
 Blit32(&kye_mixtmp[1],dest,0,0,x,y,16,16);
}
