/*
** kyeobase.h
**
** Functions & data only used by kyeobjs.c
*/



#if !defined(KYEOBASE_H)
#define KYEOBASE_H


#include "baseinc.h"



extern dword kye_colors[];
 
extern adint* kye_index_s,
            * kye_index_i,
            * kye_index_o,
            * kye_index_b;
     
extern tImage kye_mixtmp[]; /*Images for mixing to give better quality animations*/

extern byte kye_big[], /*To make these visible for kyeobjs*/
            kye_out[],
	    kye_in[],
	    kye_shap[];


/*Cleans the mix images to transparent*/
void Kye_OB_NewMix();
/*LinearSelect
**Downsamples a larger set of values to a smaller set among returning how two
**adjacent values should be mixed to get a better representation of the
**original (how much to take from the returned value; 256-m: how much from the
**following)*/
adint Kye_OB_LinearSelect(adint inv, adint inmax, adint omax, adint* m);
/*Base
**Needed by various things: basement*/
void Kye_OB_Base(sadint x, sadint y, tImage* dest, adint out, dword col, dword bcol);
/*MixBase
**Like the above, but prepares in the mixer area*/
void Kye_OB_MixBase(adint out, dword col, dword bcol);
/*RotSel
**Selects images & flags according to the given 0-23 rotation (INTENS_T
**will NOT be set)
**(use when a 0, a 15, a 30, and a 45 degree image is there in order)*/
adint Kye_OB_RotSel(adint *ino, adint rot);
/*Rot (Obsolete)
**Sets up the drawing flag & img no according to the rotation
**(Use when a 0, a 15, a 30, and a 45 degree image is present in order)*/
/*MixRot
**like the above, but sets up two image numbers for mixing together and a
**mixing ratio specifiing how much has to be taken from the first*/
void Kye_OB_MixRot(adint *ino1, adint *flags1, adint *ino2, adint *flags2, adint *mix, sadint rot);
/*Kye_OB_MixAlpha
**Mixes two alpha values appropriately (0-255 each)*/
dword Kye_OB_MixAlpha(dword a1, dword a2);
/*Kye_OB_AddAlpha
**adds more transparency to a color, returns the new color*/
dword Kye_OB_AddAlpha(dword col, dword a);
/*Kye_OB_MixCol
**Mixes two colors by taking m of the first, and 256-m of the second*/
dword Kye_OB_MixColor(dword c1, dword c2, dword m);
/*SR
**Internal stuff for slider or rocky (As they are drawn the same way)
**Also used for auto - slider & auto - rocky*/
void Kye_OB_SR(sadint rot, sadint frame, sadint x, sadint y, tImage* dest, adint shape, adint out, dword col, dword tr);


#endif
