/*
** main.c
**
** The main program file with main()
*/


#include "baseinc.h"
#include "screen.h"
#include "intro.h"
#include "gamemain.h"
#include <SDL/SDL.h>
#include "kyemapmn.h"
#include "kyeinter.h"
#include "timer.h"
#include "blit32.h"
#include "levelres.h"
#include "levelrdc.h"
#include "levelprc.h"
#include "geffects.h"
#include "text.h"


void ReadLevel(sadint no){
 ASCII7_Start(kye_level_default,KYE_LEVEL_DEFAULT_L);
 Level_GetNumLine(ASCII7_Getch);
 while (no>0){
  Kye_MapAlloc();
  Level_SkipLine(ASCII7_Getch); /*Title*/
  Level_SkipLine(ASCII7_Getch); /*Hint*/
  Level_SkipLine(ASCII7_Getch); /*Win message*/
  Level_Kye(ASCII7_Getch);      /*The level*/
  no--;
 }
}


int main(int argno, char* args[])
{

/* SDL_Event event; The event got from the queue*/
 tImage* scrmem;  /*For the screen*/
 adint i,t1,t2,t3,up=0;
 tImage t;
 sadint clev=0;
 byte* tlng[10]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
 
 /*Initialize SDL*/
 if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER)) return -1;
 /*Try to set up the screen*/
 if (Screen_Set(640,480)) return -1;
 
 if (Kye_MapSetup(15,15)) return -1;
 
 Text_Alloc(NULL);
 
 /*Some temp. bg image...*/
 t.i=malloc(sizeof(dword)*512*384);
 t.x=512;
 t.y=384;
 t.c=NULL;
 t.p=512;
 Kye_SetBGImage(&t);

 /*OK, let's go!*/ 
 
 Intro(3);

 ASCII7_Start(kye_level_default,KYE_LEVEL_DEFAULT_L);
 t1=Level_GetNumLine(ASCII7_Getch);

 while(1){

  if (up==0){
   Effect_RandomMap(0,0x171717,16,16,&t);
   Intro_Cheetah(0,0,64,&t);
   scrmem=Screen_Lock();
   if (scrmem!=NULL){
    Effect_RandomMap(0x442200,0x665511,16,64,scrmem);
    Screen_Unlock();
   }
  }

  ReadLevel(clev);

  Kye_MapAlloc();
  tlng[0]=malloc(1024+64);
  if (tlng[0]==NULL) break;
  tlng[1]=tlng[0]+64;
  t2=ASCII7_Getch();
  t3=0;
  while (t2!='\n'){
   if (t3<64) tlng[0][t3]=t2;
   t3++; t2=ASCII7_Getch();
  }
  tlng[0][t3]=0;
  t2=ASCII7_Getch();
  t3=0;
  while (t2!='\n'){
   if (t3<1024) tlng[1][t3]=t2;
   t3++; t2=ASCII7_Getch();
  }
  tlng[1][t3]=0;
  Level_SkipLine(ASCII7_Getch); /*Win message*/
  Level_Kye(ASCII7_Getch);      /*The level*/

  t2=0;
  i=0;
  switch(Game_Main(tlng,1|up)){
   case GAME_HALT: case GAME_EXIT: t2=1; break;
   case GAME_NEXT: i=1; case GAME_DIAM: clev++; up=0; break;
   case GAME_PREV: clev--; up=0; break;
   default: up=GAME_NOUPD; /*(Died - restart)*/
  }
  
  free(tlng[0]); tlng[0]=NULL; tlng[1]=NULL;

  if (clev>=((sadint)t1)){
   if (i) clev=t1-1; else break;
  }
  if (clev<0) clev=0;
  if (t2) break;
 }

 Text_Free();
 Kye_MapClose();
 SDL_Quit();

 return 0;
}
