/*
** ppcdec.c
**
** Simple PPC display module (From the Panthera engine)
*/



#include "baseinc.h"
#include "ppcdec.h"



/*Displays a PPC-PCX on the surface
**ppc is the raw PPC data to process
**sy is it's y size
**pal is the ARGB palette to use on it
**x and y is the position where it should be placed
**dest is the destination surface
**
**Note that it does not check anything, so the PPC data must be valid, and fit
**on the dest. surface
*/


void PPC_Disp(byte* ppc, adint sy, dword* pal, adint x, adint y, tImage* dest)
{
 adint cx;   //Current x position
 adint l;
 dword* img=(dest->i)+x+y*(dest->p);
 dword oc,crb,cg,t;

 while(sy>0){

  cx=0;
 
  while(1){
 
   if ((*ppc)<192){ /*Single byte*/
    /*Put color*/
    l=1;
    goto PPC_Disp_shortput; /*Not make code too long if not necessary*/

   }else if ((*ppc)==255){ /*Terminator byte*/
    ppc++;
    break;

   }else /*The rest are longer sequences*/

   if ((*ppc)<252){ /*Repeat short sequence*/
    l=(*ppc)-192; ppc++;
    /*Put color*/
    PPC_Disp_longput:
    oc=pal[*ppc];
    t=oc>>24;
    if (t==0)
     while(l>0){ img[cx]=oc+((img[cx])&0xFF000000); l--; cx++; }
    else if (t<255){
     crb=(((oc & 0xFF00FF)*(255-t))&0xFF00FF00);
     cg=(((oc & 0xFF00)*(255-t))&0xFF0000);
     while(l>0){
      img[cx]=(( (((((img[cx])&0xFF00FF)*t)&0xFF00FF00)+crb)+
                 (((((img[cx])&0xFF00)*t)&0xFF0000)+cg)
              )>>8)+((img[cx])&0xFF000000);
      l--; cx++;
     }
    }else cx+=l;
    ppc++;

   }else if ((*ppc)==252){ /*Transparent sequence*/
    ppc++;
    cx+=*ppc;
    ppc++;
   
   }else if ((*ppc)==253){ /*Rep. long*/
    ppc++;
    l=*ppc; ppc++;
    /*Put color*/
    goto PPC_Disp_longput; /*Why make it longer if it is already done?*/

   }else{  /*Must be 254... Unpacked sequence!*/
    ppc++;
    l=*ppc; ppc++;
    while(l>0){
     PPC_Disp_shortput:
     oc=pal[*ppc];
     t=oc>>24;
     if (t==0)
      img[cx]=oc+((img[cx])&0xFF000000);
     else if (t<255){
      crb=(((oc & 0xFF00FF)*(255-t))&0xFF00FF00);
      cg=(((oc & 0xFF00)*(255-t))&0xFF0000);
      img[cx]=(( (((((img[cx])&0xFF00FF)*t)&0xFF00FF00)+crb)+
                 (((((img[cx])&0xFF00)*t)&0xFF0000)+cg)
              )>>8)+((img[cx])&0xFF000000);
     }
     cx++; ppc++; l--;
    }
   }
   
  } /*Scanline while ends*/
  
  sy--; /*Next line*/
  img+=dest->p;
 }

}
