/*
** rot.c
**
** Rotations. To calculate the necessary steppings for the eight
** possible transformations of an image
*/


#include "rot.h"



/*Returns the stepping informations necessary to do a transformation
**in the return value the value to add to the pointer pointing at the
**top left corner of the destination, in sx the value to add to the
**pointer at every increase of x by one, in sy the value to add at
**every y increase.
**sx and sy is the sizes of the source (what has to be blitted on the
**destination), pitch is the destination's absolute x size (what has
**to be added to the pointer to increase y with 1).
**flags:
** MIR_X for x mirroring
** MIR_Y for y mirroring
** MIR_XY45 for mirroring on the 45 degree line
*/
sadint Rot(adint flags, sadint* sx, sadint* sy, sadint pitch)
{
 sadint x=(*sx)-1,y=(*sy)-1;
 switch (flags & (MIR_X | MIR_Y | ROT_R)){
  case MIR_X:
   *sx=1;
   *sy=-pitch;
   return y*pitch;
  case MIR_Y:
   *sx=-1;
   *sy=pitch;
   return x;
  case (MIR_X | MIR_Y):
   *sx=-1;
   *sy=-pitch;
   return (y*pitch)+x;
  case MIR_XY45:
   *sy=1;
   *sx=pitch;
   return 0;
  case (MIR_XY45 | MIR_X):
   *sy=1;
   *sx=-pitch;
   return x*pitch;
  case (MIR_XY45 | MIR_Y):
   *sy=-1;
   *sx=pitch;
   return y;
  case (MIR_XY45 | MIR_X | MIR_Y):
   *sy=-1;
   *sx=-pitch;
   return (x*pitch)+y;
  default: /*None set*/
   *sx=1;
   *sy=pitch;
   return 0;
 }
}
