/*
** rot.h
**
** Rotations. To calculate the necessary steppings for the eight
** possible transformations of an image
*/


#if !defined(ROT_H)
#define ROT_H

#include "baseinc.h"


#define  MIR_X     0x01
#define  MIR_Y     0x02
#define  MIR_XY45  0x04
#define  ROT_R     (MIR_XY45 | MIR_Y)
#define  ROT_L     (MIR_XY45 | MIR_X)
#define  ROT_R90   ROT_R
#define  ROT_L90   ROT_L
#define  ROT_180   (MIR_X | MIR_Y)
#define  ROT_0     0


/*Returns the stepping informations necessary to do a transformation
**in the return value the value to add to the pointer pointing at the
**top left corner of the destination, in sx the value to add to the
**pointer at every increase of x by one, in sy the value to add at
**every y increase.
**sx and sy is the sizes of the source (what has to be blitted on the
**destination), pitch is the destination's absolute x size (what has
**to be added to the pointer to increase y with 1).
**flags:
** MIR_X for x mirroring
** MIR_Y for y mirroring
** MIR_XY45 for mirroring on the 45 degree line
*/
sadint Rot(adint flags, sadint* sx, sadint* sy, sadint pitch);

#endif
