/*
** screen.h
**
** SDL screen handling functions
*/



#if !defined(SCREEN_H)
#define SCREEN_H

#include "baseinc.h"



/*Screen_Set()
**Sets up the screen to be a 32bit mode
**Returns 0 on success, -1 on failure
*/
sadint Screen_Set(adint x, adint y);

/*Screen_Free()
**Cleans up the previously set up screen mode
*/
void Screen_Free();

/*Screen_Lock()
**Locks the screen for drawing. Returns a pointer to the screen buffer,
**or NULL on failure
*/
tImage* Screen_Lock();

/*Screen_UnLock()
**Releases the previously set lock.
*/
void Screen_Unlock();

/*Screen_Update(x,y,w,h)
**Updates a region of the screen (makes the contents visible)
*/
void Screen_Update(sadint x, sadint y, sadint w, sadint h);

#endif

