/*
** text.h
**
** For writing text on screen
*/


#if !defined(TEXT_H)
#define TEXT_H


#include "baseinc.h"


/*Allocates memory if necessary and sets the extended charset if non - null
**is passed. The module works without this, but sloow.*/
void Text_Alloc(byte* ext);
/*Frees memory allocated to the text module. Call when exitting*/
void Text_Free();

/*Prints a null terminated string beginning at the given location
**If the text does not contain new lines, returns the width. NULL may be
**passed to only get width*/
adint Text_Print(byte* str, sadint x, sadint y, dword col, tImage*dest);
/*Outputs aligned text. Returns the height of the block in pixels. If NULL
**is passed as dest, then only calculates height. Uses the full width of the
**passed tImage (create "window"s to limit). Align can be 'c', 'l', 'r', or
**'j' (center, left, right, justify) Default is left*/
adint Text_Align(byte* str, byte align, sadint y, dword col, tImage*dest);


#endif
